Index: trunk/modules/vci_io_bridge/caba/source/src/vci_io_bridge.cpp
===================================================================
--- trunk/modules/vci_io_bridge/caba/source/src/vci_io_bridge.cpp	(revision 713)
+++ trunk/modules/vci_io_bridge/caba/source/src/vci_io_bridge.cpp	(revision 715)
@@ -1620,12 +1691,14 @@
                 }
                 r_config_cmd_to_config_rsp_rerror = rerror;
-                r_config_cmd_fsm                 = CONFIG_CMD_RSP;
+                r_config_cmd_to_config_rsp_rdata  = rdata;
+                r_config_cmd_to_config_rsp_rsrcid = p_vci_tgt_int.srcid.read();
+                r_config_cmd_to_config_rsp_rtrdid = p_vci_tgt_int.trdid.read();
+                r_config_cmd_to_config_rsp_rpktid = p_vci_tgt_int.pktid.read();
+                r_config_cmd_fsm                  = CONFIG_CMD_RSP;
             }
             else if ( found )                            // remote peripheral
             {
+                // buffer VCI command
                 r_config_cmd_address = p_vci_tgt_int.address.read();
-                r_config_cmd_srcid   = p_vci_tgt_int.srcid.read();
-                r_config_cmd_trdid   = p_vci_tgt_int.trdid.read();
-                r_config_cmd_pktid   = p_vci_tgt_int.pktid.read();
                 r_config_cmd_pktid   = p_vci_tgt_int.pktid.read();
                 r_config_cmd_plen    = p_vci_tgt_int.plen.read();
@@ -1636,45 +1709,54 @@
                 r_config_cmd_contig  = p_vci_tgt_int.contig.read();
                 r_config_cmd_cfixed  = p_vci_tgt_int.cfixed.read();
-
-                if( eop )                                // single flit command
-                {
-                    if ( high )     // HI word
-                    {
-                        r_config_cmd_wdata = ((ext_data_t)p_vci_tgt_int.wdata.read())<<32;
-                        r_config_cmd_be    = ((ext_be_t)p_vci_tgt_int.be.read())<<4;
-                        r_config_cmd_eop   = true;
-                        r_config_cmd_fsm   = CONFIG_CMD_PUT;
-                    }
-                    else            // LO word
-                    {
-                        r_config_cmd_wdata = ((ext_data_t)p_vci_tgt_int.wdata.read());
-                        r_config_cmd_be    = ((ext_be_t)p_vci_tgt_int.be.read());
-                        r_config_cmd_eop   = true;
-                        r_config_cmd_fsm   = CONFIG_CMD_PUT;
-                    }
-                }
-                else                                     // multi-flits write
-                {
-                    if ( high )     // MSB word
-                    {
-                        r_config_cmd_wdata = ((ext_data_t)p_vci_tgt_int.wdata.read())<<32;
-                        r_config_cmd_be    = ((ext_be_t)p_vci_tgt_int.be.read())<<4;
-                        r_config_cmd_eop   = false;
-                        r_config_cmd_fsm   = CONFIG_CMD_PUT;
-                    }
-                    else            // LSB word
-                    {
-                        r_config_cmd_wdata = ((ext_data_t)p_vci_tgt_int.wdata.read());
-                        r_config_cmd_be    = ((ext_be_t)p_vci_tgt_int.be.read());
-                        r_config_cmd_eop   = false;
-                        r_config_cmd_fsm   = CONFIG_CMD_NEXT;
-                    }
-                }
-            }
-            else                                         // out of segment address
-            {
+                r_config_cmd_eop     = eop;
+                r_config_cmd_wdata   = (wdata << (high ? 32 : 0));
+                r_config_cmd_be      = (be << (high ? 4 : 0));
+
+                size_t tab_index;
+                if (m_iox_transaction_tab.full(tab_index))
+                {
+#ifdef INSTRUMENTATION
+m_cpt_trt_config_full++;
+#endif
+
+                    // wait for an empty slot in the IOX transaction table.
+                    // buffer SRCID and TRDID of VCI command to store them
+                    // later in IOX transaction table.
+                    r_config_cmd_srcid = p_vci_tgt_int.srcid.read();
+                    r_config_cmd_trdid = p_vci_tgt_int.trdid.read();
+                    r_config_cmd_fsm   = CONFIG_CMD_WAIT;
+                    break;
+                }
+
+                // TRDID in IOX interconnect is the translation table index
+                r_config_cmd_trdid = tab_index;
+
+                // create new entry in IOX transaction table
+                m_iox_transaction_tab.set( tab_index,
+                        p_vci_tgt_int.srcid.read(),
+                        p_vci_tgt_int.trdid.read());
+
+                if (eop) r_config_cmd_fsm = CONFIG_CMD_PUT;
+                else     r_config_cmd_fsm = CONFIG_CMD_HI;
+
+#if DEBUG_CONFIG_CMD
+if( m_debug_activated )
+{
+std::cout << name()
+          << "  <IOB CONFIG_CMD_IDLE> ### new entry in IOX transaction table"
+          << std::endl;
+m_iox_transaction_tab.printTrace();
+}
+#endif
+
+            }
+            else if ( eop )                                   // out of segment address
+            {
+                r_config_cmd_to_config_rsp_rerror = true;
                 r_config_cmd_to_config_rsp_rdata  = 0;
-                r_config_cmd_to_config_rsp_rerror = true;
-                if( eop ) r_config_cmd_fsm        = CONFIG_CMD_RSP;
+                r_config_cmd_to_config_rsp_rsrcid = p_vci_tgt_int.srcid.read();
+                r_config_cmd_to_config_rsp_rtrdid = p_vci_tgt_int.trdid.read();
+                r_config_cmd_to_config_rsp_rpktid = p_vci_tgt_int.pktid.read();
+                r_config_cmd_fsm                  = CONFIG_CMD_RSP;
             }
         } // end if cmdval
@@ -1682,10 +1764,44 @@
     }
     /////////////////////
-    case CONFIG_CMD_NEXT:  // Consume the second flit for a multi-flits write 
-    {
-        if ( p_vci_tgt_int.cmdval.read() ) 
+    case CONFIG_CMD_WAIT:
+    {
+        // wait for an empty slot in the translation table.
+        size_t tab_index;
+        if (m_iox_transaction_tab.full(tab_index))
+        {
+#ifdef INSTRUMENTATION
+m_cpt_trt_config_full_cost++;
+#endif
+            break;
+        }
+
+        // create new entry in IOX transaction table
+        m_iox_transaction_tab.set( tab_index,
+                r_config_cmd_srcid.read(),
+                r_config_cmd_trdid.read());
+
+        // TRDID in IOX interconnect is the translation table index
+        r_config_cmd_trdid = tab_index;
+        if (r_config_cmd_eop.read()) r_config_cmd_fsm = CONFIG_CMD_PUT;
+        else                         r_config_cmd_fsm = CONFIG_CMD_HI;
+
+#if DEBUG_CONFIG_CMD
+if( m_debug_activated )
+{
+std::cout << name()
+          << "  <IOB CONFIG_CMD_WAIT> ### new entry in IOX transaction table"
+          << std::endl;
+m_iox_transaction_tab.printTrace();
+}
+#endif
+        break;
+    }
+    /////////////////////
+    case CONFIG_CMD_HI:  // consume the second flit for a multi-flits write
+    {
+        if ( p_vci_tgt_int.cmdval.read() )
         {
             vci_addr_t paddr = p_vci_tgt_int.address.read();
-            bool       high  = (paddr & 0x4 == 0x4);
+            bool       high  = ((paddr & 0x4) == 0x4);
             bool       eop   = p_vci_tgt_int.eop.read();
 
@@ -1702,4 +1818,26 @@
         break;
     }
+    /////////////////////
+    case CONFIG_CMD_LO:  // consume the first flit for a multi-flits write
+    {
+        if ( p_vci_tgt_int.cmdval.read() )
+        {
+            vci_addr_t paddr = p_vci_tgt_int.address.read();
+            bool       high  = ((paddr & 0x4) == 0x4);
+            bool       eop   = p_vci_tgt_int.eop.read();
+
+            assert( (paddr == r_config_cmd_address.read() + 4) and !high and
+            "ERROR in vci_io_bridge : addresses must be contiguous in write burst" );
+
+            r_config_cmd_address = p_vci_tgt_int.address.read();
+            r_config_cmd_wdata   = (ext_data_t)p_vci_tgt_int.wdata.read();
+            r_config_cmd_be      = (ext_be_t)p_vci_tgt_int.be.read();
+            r_config_cmd_eop     = eop;
+
+            if (eop) r_config_cmd_fsm = CONFIG_CMD_PUT;
+            else     r_config_cmd_fsm = CONFIG_CMD_HI;
+        }
+        break;
+    }
     ////////////////////
     case CONFIG_CMD_PUT:   // post a command to CONFIG_CMD fifo (to IOX network)
@@ -1711,20 +1849,23 @@
 
 #if DEBUG_CONFIG_CMD
-if( m_debug_activated ) 
-std::cout << "  <IOB CONFIG_CMD_PUT> Transmit VCI command to IOX network"
+if( m_debug_activated )
+std::cout << name()
+          << "  <IOB CONFIG_CMD_PUT> Transmit VCI command to IOX network"
           << " : address = " << std::hex << r_config_cmd_address.read()
-          << " / srcid = " << r_config_cmd_srcid.read()
+          << " / srcid = " << m_iox_srcid
+          << " / trdid = " << r_config_cmd_trdid.read()
           << " / eop = " << r_config_cmd_eop.read()
           << std::endl;
 #endif
-            r_config_cmd_fsm = CONFIG_CMD_IDLE;
+            if (r_config_cmd_eop.read()) r_config_cmd_fsm = CONFIG_CMD_IDLE;
+            else                         r_config_cmd_fsm = CONFIG_CMD_LO;
         }
         break;
     }
     ////////////////////
-    case CONFIG_CMD_RSP:   // Post a request to CONFIG_RSP FSM, 
+    case CONFIG_CMD_RSP:   // Post a request to CONFIG_RSP FSM,
                            // if no previous pending request.
                            // r_config_cmd_to_config_rsp_rerror
-                           // has been set in IDLE state. 
+                           // has been set in IDLE state.
     {
         if ( not r_config_cmd_to_config_rsp_req.read() )
@@ -1733,6 +1874,7 @@
 
 #if DEBUG_CONFIG_CMD
-if( m_debug_activated ) 
-std::cout << "  <IOB CONFIG_CMD_RSP> Request a response to CONFIG_RSP FSM"
+if( m_debug_activated )
+std::cout << name()
+          << "  <IOB CONFIG_CMD_RSP> Request a response to CONFIG_RSP FSM"
           << " / error = " << r_config_cmd_to_config_rsp_rerror.read() << std::endl;
 #endif
@@ -1748,7 +1890,7 @@
     // - CONFIG_CMD : response to a local config command.
     // - CONFIG_RSP : responses from peripherals on IOX network
-    // Regarding the responses from IOX network it handles both single flit 
-    // config responses, and multi-flits read responses (ROM), where data must 
-    // be serialised (64 bits -> 32 bits). 
+    // Regarding the responses from IOX network it handles both single flit
+    // config responses, and multi-flits read responses (ROM), where data must
+    // be serialised (64 bits -> 32 bits).
     // Note: We use the VCI RPKTID field to distinguish between read cached
     // (multi-flits response) and others (single flit response).
@@ -1759,50 +1901,84 @@
     if ( m_config_rsp_rerror_fifo.wok() )
     {
-        switch( r_config_rsp_fsm.read() ) 
+        switch( r_config_rsp_fsm.read() )
         {
             /////////////////////////
             case CONFIG_RSP_IDLE_IOX:  // IOX requests have highest priority
                                        // no flit on IOX network is consumed
-            {    	
+            {
                 if ( p_vci_ini_iox.rspval.read() )  // IOX request
-	            {
-                    if ( (p_vci_ini_iox.rpktid.read() & 0x5) == 0x1 )   // multi-flits 
+                {
+                    // recover srcid and trdid from the IOX transaction table
+                    size_t tab_index = (size_t)p_vci_ini_iox.rtrdid.read();
+                    r_config_rsp_rsrcid = m_iox_transaction_tab.readSrcid(tab_index);
+                    r_config_rsp_rtrdid = m_iox_transaction_tab.readTrdid(tab_index);
+
+                    // erase entry
+                    m_iox_transaction_tab.erase(tab_index);
+
+                    if ( (p_vci_ini_iox.rpktid.read() & 0x5) == 0x1 )   // multi-flits
                     {
-                        r_config_rsp_fsm   = CONFIG_RSP_PUT_LOW;
+                        r_config_rsp_fsm   = CONFIG_RSP_PUT_LO;
                     }
-                    else                                                // single flit    
+                    else                                                // single flit
                     {
                         r_config_rsp_fsm   = CONFIG_RSP_PUT_UNC;
                     }
-    		    }
-                else if ( r_config_cmd_to_config_rsp_req.read() ) // LOC request
+#if DEBUG_CONFIG_RSP
+if( m_debug_activated )
+{
+std::cout << name()
+          << "  <IOB CONFIG_RSP_IDLE_IOX> ### remove entry in transaction table"
+          << std::endl;
+m_iox_transaction_tab.printTrace();
+}
+#endif
+                }
+                else if ( r_config_cmd_to_config_rsp_req.read() ) // LOCAL request
                 {
                     r_config_rsp_fsm = CONFIG_RSP_PUT_LOC;
                 }
-    		    break;
+                break;
             }
             /////////////////////////
-            case CONFIG_RSP_IDLE_LOC:  // LOC requests have highest priority
+            case CONFIG_RSP_IDLE_LOC:  // LOCAL requests have highest priority
                                        // no flit on IOX network is consumed
-            {    	
-                if ( r_config_cmd_to_config_rsp_req.read() ) // LOC request
+            {
+                if ( r_config_cmd_to_config_rsp_req.read() ) // LOCAL request
                 {
                     r_config_rsp_fsm = CONFIG_RSP_PUT_LOC;
                 }
                 else if ( p_vci_ini_iox.rspval.read() ) // IOX request
-	            {
-                    if ( (p_vci_ini_iox.rpktid.read() & 0x5) == 0x1 )   // multi-flits 
+                {
+                    // recover srcid and trdid from the IOX transaction table
+                    size_t tab_index = (size_t)p_vci_ini_iox.rtrdid.read();
+                    r_config_rsp_rsrcid = m_iox_transaction_tab.readSrcid(tab_index);
+                    r_config_rsp_rtrdid = m_iox_transaction_tab.readTrdid(tab_index);
+
+                    // erase entry
+                    m_iox_transaction_tab.erase(tab_index);
+
+                    if ( (p_vci_ini_iox.rpktid.read() & 0x5) == 0x1 )   // multi-flits
                     {
-                        r_config_rsp_fsm   = CONFIG_RSP_PUT_LOW;
+                        r_config_rsp_fsm   = CONFIG_RSP_PUT_LO;
                     }
-                    else                                                // single flit    
+                    else                                                // single flit
                     {
                         r_config_rsp_fsm   = CONFIG_RSP_PUT_UNC;
                     }
-    		    }
-               	break;
+#if DEBUG_CONFIG_RSP
+if( m_debug_activated )
+{
+std::cout << name()
+          << "  <IOB CONFIG_RSP_IDLE_IOX> ### remove entry in transaction table"
+          << std::endl;
+m_iox_transaction_tab.printTrace();
+}
+#endif
+                }
+                break;
             }
             ////////////////////////
-            case CONFIG_RSP_PUT_LOW:   // put 32 low bits into CONFIG_RSP fifo
+            case CONFIG_RSP_PUT_LO:   // put 32 low bits into CONFIG_RSP fifo
                                        // no flit on IOX network is consumed
             {
@@ -1810,6 +1986,6 @@
                 config_rsp_fifo_rerror = p_vci_ini_iox.rerror.read();
                 config_rsp_fifo_rdata  = (uint32_t)p_vci_ini_iox.rdata.read();
-                config_rsp_fifo_rsrcid = p_vci_ini_iox.rsrcid.read();
-                config_rsp_fifo_rtrdid = p_vci_ini_iox.rtrdid.read();
+                config_rsp_fifo_rsrcid = r_config_rsp_rsrcid.read();
+                config_rsp_fifo_rtrdid = r_config_rsp_rtrdid.read();
                 config_rsp_fifo_rpktid = p_vci_ini_iox.rpktid.read();
                 config_rsp_fifo_reop   = false;
@@ -1818,8 +1994,9 @@
 
 #if DEBUG_CONFIG_RSP
-if( m_debug_activated ) 
-std::cout << "  <IOB CONFIG_RSP_PUT_LOW> Push multi-flit response into CONFIG_RSP FIFO" 
-          << " / rsrcid = " << std::hex << p_vci_ini_iox.rsrcid.read()
-          << " / rtrdid = " << p_vci_ini_iox.rtrdid.read()
+if( m_debug_activated )
+std::cout << name()
+          << "  <IOB CONFIG_RSP_PUT_LO> Push multi-flit response into CONFIG_RSP FIFO"
+          << " / rsrcid = " << std::hex << r_config_rsp_rsrcid.read()
+          << " / rtrdid = " << r_config_rsp_rtrdid.read()
           << " / rpktid = " << p_vci_ini_iox.rpktid.read()
           << " / rdata = " << (uint32_t)p_vci_ini_iox.rdata.read()
@@ -1827,26 +2004,27 @@
           << " / rerror = " << p_vci_ini_iox.rerror.read() << std::endl;
 #endif
-    	        break;
+                break;
             }
             ///////////////////////
             case CONFIG_RSP_PUT_HI:    // put 32 high bits into CONFIG_RSP fifo
-                                   // flit on IOX network is consumed 
+                                   // flit on IOX network is consumed
             {
                 config_rsp_fifo_put    = true;
                 config_rsp_fifo_rerror = p_vci_ini_iox.rerror.read();
                 config_rsp_fifo_rdata  = (uint32_t)(p_vci_ini_iox.rdata.read() >> 32);
-                config_rsp_fifo_rsrcid = p_vci_ini_iox.rsrcid.read();
-                config_rsp_fifo_rtrdid = p_vci_ini_iox.rtrdid.read();
+                config_rsp_fifo_rsrcid = r_config_rsp_rsrcid.read();
+                config_rsp_fifo_rtrdid = r_config_rsp_rtrdid.read();
                 config_rsp_fifo_rpktid = p_vci_ini_iox.rpktid.read();
                 config_rsp_fifo_reop   = p_vci_ini_iox.reop.read();
 
                 if( p_vci_ini_iox.reop.read() ) r_config_rsp_fsm = CONFIG_RSP_IDLE_LOC;
-                else                            r_config_rsp_fsm = CONFIG_RSP_PUT_LOW;
+                else                            r_config_rsp_fsm = CONFIG_RSP_PUT_LO;
 
 #if DEBUG_CONFIG_RSP
-if( m_debug_activated ) 
-std::cout << "  <IOB CONFIG_RSP_PUT_HI> Push multi-flit response into CONFIG_RSP FIFO" 
-          << " / rsrcid = " << std::hex << p_vci_ini_iox.rsrcid.read()
-          << " / rtrdid = " << p_vci_ini_iox.rtrdid.read()
+if( m_debug_activated )
+std::cout << name()
+          << "  <IOB CONFIG_RSP_PUT_HI> Push multi-flit response into CONFIG_RSP FIFO"
+          << " / rsrcid = " << std::hex << r_config_rsp_rsrcid.read()
+          << " / rtrdid = " << r_config_rsp_rtrdid.read()
           << " / rpktid = " << p_vci_ini_iox.rpktid.read()
           << " / rdata = " << (uint32_t)(p_vci_ini_iox.rdata.read() >> 32)
@@ -1854,11 +2032,11 @@
           << " / rerror = " << p_vci_ini_iox.rerror.read() << std::endl;
 #endif
-    	        break;
+                break;
             }
             ////////////////////////
             case CONFIG_RSP_PUT_UNC:   // put single flit into CONFIG_RSP fifo
-                                       // flit on IOX network is consumed 
-            {
-                assert(  p_vci_ini_iox.reop.read() and 
+                                       // flit on IOX network is consumed
+            {
+                assert(  p_vci_ini_iox.reop.read() and
                 "ERROR in vci_io_bridge : a remote config response should be one flit");
 
@@ -1866,6 +2044,6 @@
                 config_rsp_fifo_rerror = p_vci_ini_iox.rerror.read();
                 config_rsp_fifo_rdata  = (uint32_t)p_vci_ini_iox.rdata.read();
-                config_rsp_fifo_rsrcid = p_vci_ini_iox.rsrcid.read();
-                config_rsp_fifo_rtrdid = p_vci_ini_iox.rtrdid.read();
+                config_rsp_fifo_rsrcid = r_config_rsp_rsrcid.read();
+                config_rsp_fifo_rtrdid = r_config_rsp_rtrdid.read();
                 config_rsp_fifo_rpktid = p_vci_ini_iox.rpktid.read();
                 config_rsp_fifo_reop   = true;
@@ -1875,8 +2053,9 @@
 
 #if DEBUG_CONFIG_RSP
-if( m_debug_activated ) 
-std::cout << "  <IOB CONFIG_RSP_PUT_UNC> Push single flit response into CONFIG_RSP FIFO" 
-          << " / rsrcid = " << std::hex << p_vci_ini_iox.rsrcid.read()
-          << " / rtrdid = " << p_vci_ini_iox.rtrdid.read()
+if( m_debug_activated )
+std::cout << name()
+          << "  <IOB CONFIG_RSP_PUT_UNC> Push single flit response into CONFIG_RSP FIFO"
+          << " / rsrcid = " << std::hex << r_config_rsp_rsrcid.read()
+          << " / rtrdid = " << r_config_rsp_rtrdid.read()
           << " / rpktid = " << p_vci_ini_iox.rpktid.read()
           << " / rdata = " << (uint32_t)p_vci_ini_iox.rdata.read()
@@ -1884,19 +2063,19 @@
           << " / rerror = " << p_vci_ini_iox.rerror.read() << std::endl;
 #endif
-    	        break;
+                break;
             }
             ////////////////////////
             case CONFIG_RSP_PUT_LOC:   // put single flit into CONFIG_RSP fifo
-                                       // no flit on IOX network is consumed 
+                                       // no flit on IOX network is consumed
             {
                 config_rsp_fifo_put    = true;
                 config_rsp_fifo_rerror = r_config_cmd_to_config_rsp_rerror.read();
                 config_rsp_fifo_rdata  = r_config_cmd_to_config_rsp_rdata.read();
-                config_rsp_fifo_rsrcid = r_config_cmd_srcid.read();
-                config_rsp_fifo_rtrdid = r_config_cmd_trdid.read();
-                config_rsp_fifo_rpktid = r_config_cmd_pktid.read();
+                config_rsp_fifo_rsrcid = r_config_cmd_to_config_rsp_rsrcid.read();
+                config_rsp_fifo_rtrdid = r_config_cmd_to_config_rsp_rtrdid.read();
+                config_rsp_fifo_rpktid = r_config_cmd_to_config_rsp_rpktid.read();
                 config_rsp_fifo_reop   = true;
 
-                // acknowledge request 
+                // acknowledge request
                 r_config_cmd_to_config_rsp_req = false;
 
@@ -1905,14 +2084,15 @@
 
 #if DEBUG_CONFIG_RSP
-if( m_debug_activated ) 
-std::cout << "  <IOB CONFIG_RSP_PUT_UNC> Push single flit response into CONFIG_RSP FIFO" 
-          << " / rsrcid = " << std::hex << r_config_cmd_srcid.read()
-          << " / rtrdid = " << r_config_cmd_trdid.read()
-          << " / rpktid = " << r_config_cmd_pktid.read()
+if( m_debug_activated )
+std::cout << name()
+          << "  <IOB CONFIG_RSP_PUT_UNC> Push single flit response into CONFIG_RSP FIFO"
+          << " / rsrcid = " << std::hex << r_config_cmd_to_config_rsp_rsrcid.read()
+          << " / rtrdid = " << r_config_cmd_to_config_rsp_rtrdid.read()
+          << " / rpktid = " << r_config_cmd_to_config_rsp_rpktid.read()
           << " / rdata = "  << r_config_cmd_to_config_rsp_rdata.read()
           << " / reop  = "  << true
           << " / rerror = " << r_config_cmd_to_config_rsp_rerror.read() << std::endl;
 #endif
-    	        break;
+                break;
             }
         } // end switch CONFIG_RSP FSM
@@ -1927,17 +2107,17 @@
     //    MISS_WTI_RSP FSM only when the response is received.
     // 2. WTI requests from DMA_CMD FSM :
-    //    These requestsare non blocking events, and the r_dma_cmd_to_miss_wti_cmd_req 
-    //    flip-flop is reset as soon as the WTI command has been sent. 
+    //    These requestsare non blocking events, and the r_dma_cmd_to_miss_wti_cmd_req
+    //    flip-flop is reset as soon as the WTI command has been sent.
     //    There is two types of WTI requests:
     //    - external WTI from peripherals on IOX network.
     //    - internal WTI caused by illegal DMA requests.
     ////////////////////////////////////////////////////////////////////////////////////
- 
-    if ( r_tlb_to_miss_wti_cmd_req.read() and  
+
+    if ( r_tlb_to_miss_wti_cmd_req.read() and
          m_miss_wti_cmd_addr_fifo.wok() )                   // put MISS READ
     {
         miss_wti_cmd_fifo_put     = true;
-        miss_wti_cmd_fifo_address = r_tlb_paddr.read();      
-        miss_wti_cmd_fifo_wdata   = 0;                 
+        miss_wti_cmd_fifo_address = r_tlb_paddr.read();
+        miss_wti_cmd_fifo_wdata   = 0;
         miss_wti_cmd_fifo_cmd     = vci_param_int::CMD_READ;
         miss_wti_cmd_fifo_pktid   = PKTID_MISS;
@@ -1947,10 +2127,11 @@
 #if DEBUG_MISS_WTI_CMD
 if( m_debug_activated )
-std::cout << "  <IOB MISS_WTI_CMD_WTI> push MISS TLB command into MISS_WTI FIFO"
+std::cout << name()
+          << "  <IOB MISS_WTI_CMD_WTI> push MISS TLB command into MISS_WTI FIFO"
           << " / PADDR = " << miss_wti_cmd_fifo_address << std::endl;
 #endif
 
     }
-    else if ( r_dma_cmd_to_miss_wti_cmd_req.read() and  
+    else if ( r_dma_cmd_to_miss_wti_cmd_req.read() and
               m_miss_wti_cmd_addr_fifo.wok() )               // put WTI READ / WRITE
     {
@@ -1967,25 +2148,26 @@
 #if DEBUG_MISS_WTI_CMD
 if( m_debug_activated )
-std::cout << "  <IOB MISS_WTI_CMD_WTI> push WTI command into MISS_WTI FIFO"
+std::cout << name()
+          << "  <IOB MISS_WTI_CMD_WTI> push WTI command into MISS_WTI FIFO"
           << " / CMD = " << miss_wti_cmd_fifo_cmd
           << " / PADDR = " << miss_wti_cmd_fifo_address << std::endl;
 #endif
 
-    }     
+    }
 
     ///////////////////////////////////////////////////////////////////////////////////
     // The MISS_WTI_RSP FSM handles VCI responses from the INT network:
     // - for a TLB MISS (multi-flits read transaction), the cache line
-    //   is written in r_tlb_buf_data[], and r_tlb_to_miss_wti_cmd_req flip-flop is reset.  
+    //   is written in r_tlb_buf_data[], and r_tlb_to_miss_wti_cmd_req flip-flop is reset.
     // - for a WTI_IOX (single flit write transaction), the response must be
     //   forwarded to the source peripheral on the INT network
     // - for a WTI_MMU (single flit write transaction), there is nothing to do.
     //
-    // TODO VCI addressing errors for TLB MISS or for WTI_MMU (i.e. kernel errors...) 
+    // TODO VCI addressing errors for TLB MISS or for WTI_MMU (i.e. kernel errors...)
     // are registered in the r_miss_wti_rsp_error_miss & r_miss_wti_rsp_error_wti
     // flip-flops, and simulation stops... They could be signaled to OS by a WTI.
     ////////////////////////////////////////////////////////////////////////////////////
- 
-    switch ( r_miss_wti_rsp_fsm.read() ) 
+
+    switch ( r_miss_wti_rsp_fsm.read() )
     {
         ///////////////////////
@@ -1993,11 +2175,11 @@
                                   // no VCI flit is consumed
         {
-            if ( p_vci_ini_int.rspval.read() ) 
-            {
-                if ( p_vci_ini_int.rpktid.read() == PKTID_WTI_IOX ) 
+            if ( p_vci_ini_int.rspval.read() )
+            {
+                if ( p_vci_ini_int.rpktid.read() == PKTID_WTI_IOX )
                 {
                     r_miss_wti_rsp_fsm   = MISS_WTI_RSP_WTI_IOX;
                 }
-                else if ( p_vci_ini_int.rpktid.read() == PKTID_WTI_MMU ) 
+                else if ( p_vci_ini_int.rpktid.read() == PKTID_WTI_MMU )
                 {
                     r_miss_wti_rsp_fsm   = MISS_WTI_RSP_WTI_MMU;
@@ -2022,7 +2204,7 @@
                                      // if no pending previous request.
         {
-            assert( p_vci_ini_int.reop.read() and 
-            "VCI_IO_BRIDGE ERROR: WTI_IOX response should have one single flit" ); 
-                    
+            assert( p_vci_ini_int.reop.read() and
+            "VCI_IO_BRIDGE ERROR: WTI_IOX response should have one single flit" );
+
             if ( not r_miss_wti_rsp_to_dma_rsp_req.read() ) // no previous pending request
             {
@@ -2037,37 +2219,39 @@
 #if DEBUG_MISS_WTI_RSP
 if( m_debug_activated )
-std::cout << "  <IOB MISS_WTI_RSP_WTI_IOX> Transfer response to a WTI_IOX" << std::endl;
+std::cout << name()
+          << "  <IOB MISS_WTI_RSP_WTI_IOX> Transfer response to a WTI_IOX" << std::endl;
 #endif
             }
             break;
         }
-        //////////////////////////  
+        //////////////////////////
         case MISS_WTI_RSP_WTI_MMU:   // Handling response to an iommu WTI
                                      // consume VCI flit and test VCI error.
         {
-            assert( p_vci_ini_int.reop.read() and 
-            "VCI_IO_BRIDGE ERROR: WTI_MMU response should have one single flit" ); 
-                 
+            assert( p_vci_ini_int.reop.read() and
+            "VCI_IO_BRIDGE ERROR: WTI_MMU response should have one single flit" );
+
             if ( (p_vci_ini_int.rerror.read()&0x1) != 0 )  // error reported
             {
                 // set the specific error flip-flop
                 r_miss_wti_rsp_error_wti = true;
-                assert( false and 
+                assert( false and
                 "VCI_IO_BRIDGE ERROR: VCI error response for a WTI_MMU transaction");
             }
 
 #if DEBUG_MISS_WTI_RSP
-if( m_debug_activated ) 
-std::cout << " <IOB MISS_WTI_RSP_WTI_MMU> Receive response to a WTI_MMU" << std::endl; 
+if( m_debug_activated )
+std::cout << name()
+          << " <IOB MISS_WTI_RSP_WTI_MMU> Receive response to a WTI_MMU" << std::endl;
 #endif
             break;
         }
         ///////////////////////
-        case MISS_WTI_RSP_MISS:   // Handling response to a TLB MISS 
+        case MISS_WTI_RSP_MISS:   // Handling response to a TLB MISS
                                   // write cache line in r_tlb_buf buffer
                                   // and analyse possible VCI error
                                   // VCI flit is consumed.
         {
-            if ( p_vci_ini_int.rspval.read() ) 
+            if ( p_vci_ini_int.rspval.read() )
             {
                 if ( (p_vci_ini_int.rerror.read()&0x1) != 0 )  // error reported
@@ -2075,5 +2259,5 @@
                     // set the specific error flip-flop
                     r_miss_wti_rsp_error_miss = true;
-                    assert( false and 
+                    assert( false and
                     "VCI_IO_BRIDGE ERROR: VCI error response for a TLB MISS transaction");
 
@@ -2082,24 +2266,25 @@
                 {
 
-#if DEBUG_MISS_WTI_CMD 
-if( m_debug_activated ) 
-std::cout << "  <IOB MISS_WTI_RSP_MISS> Receive response to a TLB MISS"
+#if DEBUG_MISS_WTI_CMD
+if( m_debug_activated )
+std::cout << name()
+          << "  <IOB MISS_WTI_RSP_MISS> Receive response to a TLB MISS"
           << " / Count = " << r_miss_wti_rsp_count.read()
-          << " / Data = " << std::hex << p_vci_ini_int.rdata.read() << std::endl; 
+          << " / Data = " << std::hex << p_vci_ini_int.rdata.read() << std::endl;
 #endif
                     r_tlb_buf_data[r_miss_wti_rsp_count.read()] = p_vci_ini_int.rdata.read();
                 }
-                    
+
                 if ( p_vci_ini_int.reop.read() )               // last flit
-                {    
+                {
                     bool eop = p_vci_ini_int.eop.read();
-                    assert(((eop == (r_miss_wti_rsp_count.read() == (m_words-1)))) and 
+                    assert(((eop == (r_miss_wti_rsp_count.read() == (m_words-1)))) and
                     "VCI_IO_BRIDGE ERROR: invalid length for a TLB MISS response");
 
                     r_miss_wti_rsp_count      = 0;
                     r_miss_wti_rsp_fsm        = MISS_WTI_RSP_IDLE;
-                    r_tlb_to_miss_wti_cmd_req = false; 
-                }
-                else                                           // not the last flit 
+                    r_tlb_to_miss_wti_cmd_req = false;
+                }
+                else                                           // not the last flit
                 {
                     r_miss_wti_rsp_count = r_miss_wti_rsp_count.read() + 1;
@@ -2142,5 +2327,5 @@
     m_dma_cmd_srcid_fifo.update(  dma_cmd_fifo_get,
                                   dma_cmd_fifo_put,
-                                  p_vci_tgt_iox.srcid.read() );
+                                  dma_cmd_fifo_srcid );
     m_dma_cmd_trdid_fifo.update(  dma_cmd_fifo_get,
                                   dma_cmd_fifo_put,
